var _path = require('path');

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports.generateNeededDir = function (dir) {
  var dirs = [(0, _path.join)(dir, '.coren', 'tmp'), (0, _path.join)(dir, '.coren', 'commonjs'), (0, _path.join)(dir, '.coren', 'html')];
  dirs.forEach(function (d) {
    return _mkdirp2['default'].sync(d);
  });
};
// .coren
exports.corenDir = function (dir) {
  return (0, _path.join)(dir, '.coren');
};

exports.clientTmpEntryDir = function (dir) {
  return (0, _path.join)(dir, '.coren', 'tmp');
};

exports.assetsJSON = function (dir) {
  return (0, _path.join)(dir, '.coren', 'assets.json');
};

exports.ssrDir = function (dir) {
  return (0, _path.join)(dir, '.coren', 'html');
};

exports.outputCommonJSDir = function (dir) {
  return (0, _path.join)(dir, '.coren', 'commonjs');
};

exports.getEnv = function () {
  if (process.env.COREN_ENV) {
    return process.env.COREN_ENV;
  }
  if (process.env.NODE_ENV === 'development') {
    return 'development';
  }
  return 'production';
};

exports.preserveEntry = ['$vendor'];