var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var hook = require('../shared/componentHook');

var App = function () {
  function App(_ref) {
    var path = _ref.path;

    _classCallCheck(this, App);

    this.collectors = [];
    this.collectorsMap = {};
    this.path = path;
    hook.bindComponentDidImport(this.componentDidImport.bind(this));
    hook.bindComponentDidConstruct(this.componentDidConstruct.bind(this));
  }

  _createClass(App, [{
    key: 'componentDidImport',
    value: function () {
      function componentDidImport(id, component) {
        this.collectors.forEach(function (collector) {
          if (collector.ifEnter(component) && collector.componentDidImport) {
            collector.componentDidImport(id, component);
          }
        });
      }

      return componentDidImport;
    }()
  }, {
    key: 'componentDidConstruct',
    value: function () {
      function componentDidConstruct(id, component, props) {
        this.collectors.forEach(function (collector) {
          if (collector.ifEnter(component) && collector.componentDidConstruct) {
            collector.componentDidConstruct(id, component, props);
          }
        });
      }

      return componentDidConstruct;
    }()
  }, {
    key: 'routeWillRender',
    value: function () {
      var _ref2 = _asyncToGenerator(function* (route) {
        for (var i = 0; i < this.collectors.length; i++) {
          if (this.collectors[i].routeWillRender) {
            yield this.collectors[i].routeWillRender(route);
          }
        }
      });

      function routeWillRender(_x) {
        return _ref2.apply(this, arguments);
      }

      return routeWillRender;
    }()
  }, {
    key: 'registerCollector',
    value: function () {
      function registerCollector(key, collector) {
        this.collectors.push(collector);
        this.collectorsMap[key] = collector;
      }

      return registerCollector;
    }()
  }, {
    key: 'getCollector',
    value: function () {
      function getCollector(key) {
        return this.collectorsMap[key];
      }

      return getCollector;
    }()
  }, {
    key: 'import',
    value: function () {
      function _import() {
        return require(this.path);
      }

      return _import;
    }()
  }, {
    key: 'appWillRender',
    value: function () {
      function appWillRender() {
        return Promise.all(this.collectors.map(function (collector) {
          return collector.appWillRender ? collector.appWillRender() : Promise.resolve();
        }));
      }

      return appWillRender;
    }()
  }]);

  return App;
}();

module.exports = App;