var _path = require('path');

var _app = require('./app');

var _app2 = _interopRequireDefault(_app);

var _CONFIG = require('./CONFIG');

var _utils = require('./utils');

var _lodash = require('lodash');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

exports.addClientEntry = function (dir, config) {
  var entry = config.entry;

  var clientEntryDir = (0, _CONFIG.clientTmpEntryDir)(dir);
  config.clientEntry = {};
  for (var key in entry) {
    var entryPath = entry[key];
    var clientEntryPath = void 0;
    if ((0, _lodash.isString)(entryPath)) {
      clientEntryPath = (0, _path.join)(clientEntryDir, entryPath);
    } else if ((0, _lodash.isArray)(entryPath)) {
      clientEntryPath = entryPath.map(function (path) {
        // if isFile: transform its path to .coren file, else: is node_module
        if ((0, _utils.isFile)(path)) {
          return (0, _path.join)(clientEntryDir, path);
        }
        return path;
      });
    }
    config.clientEntry[key] = clientEntryPath;
  }

  return config;
};

exports.createClientTmpEntryFile = function (dir, config) {
  var clientImport = 'import React from \'react\';\n     import ReactDOM from \'react-dom\';';
  var clientRender = '<App/>';
  var entry = config.entry;
  // use first entry js to get collector's wrapClientRender & wrapClientImport

  var firstKey = Object.keys(entry)[0];
  var app = new _app2['default']({ path: (0, _path.resolve)((0, _CONFIG.outputCommonJSDir)(dir), String(firstKey) + '.commonjs2.js') });
  if (config.registerCollector) {
    app = config.registerCollector(app, { context: {} });
  }
  app.collectors.forEach(function (collector) {
    // collect wrapClientImport & wrapClientRender content
    if (collector.wrapClientImport) {
      clientImport += collector.wrapClientImport();
    }
    if (collector.wrapClientRender) {
      clientRender = collector.wrapClientRender(clientRender);
    }
  });
  clientRender = 'ReactDOM.render(\n      <div>\n        ' + String(clientRender) + '\n      </div>\n    , document.getElementById(\'root\'));';
  for (var key in entry) {
    // entryPath: ./src/index.js
    var entryPath = entry[key];
    if (_lodash.isString[entryPath]) {
      entryPath = [entryPath];
    }
    for (var i in entryPath) {
      var path = entryPath[i];
      if ((0, _utils.isFile)(path)) {
        // clientTmpDir: /.coren/tmp
        var clientTmpDir = (0, _CONFIG.clientTmpEntryDir)(dir);
        // clientEntryPath: /.coren/tmp/src/index.js
        var clientEntryPath = (0, _path.join)(clientTmpDir, entryPath);
        // clientEntryDir: /.coren/tmp/src
        var clientEntryDir = (0, _path.resolve)(clientEntryPath, '../');
        _mkdirp2['default'].sync(clientEntryDir);
        // importPath
        var importPath = (0, _path.relative)(clientEntryDir, (0, _path.join)(dir, entryPath));
        var tmpJS = String(clientImport) + '\n           import App from "' + String(importPath) + '";\n           ' + String(clientRender);
        _fs2['default'].writeFileSync(clientEntryPath, tmpJS, 'utf8');
      }
    }
  }
};