var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('redux'),
    createStore = _require.createStore;

var _require2 = require('react-redux'),
    Provider = _require2.Provider;

var react = require('react');
var Promise = require('bluebird');

var ReduxCollector = function () {
  function ReduxCollector(_ref) {
    var componentProps = _ref.componentProps,
        reducers = _ref.reducers,
        configureStore = _ref.configureStore;

    _classCallCheck(this, ReduxCollector);

    if (!configureStore) {
      throw new Error("configureStore is required in ReduxCollector");
    }
    this.preloadedStateGenerators = [];
    this.initialState = {};
    this.componentProps = componentProps;
    this.reducers = reducers;
    this.configureStore = configureStore;
  }

  _createClass(ReduxCollector, [{
    key: 'ifEnter',
    value: function () {
      function ifEnter(component) {
        return component.definePreloadedState;
      }

      return ifEnter;
    }()
  }, {
    key: 'componentDidImport',
    value: function () {
      function componentDidImport(id, component) {
        this.preloadedStateGenerators.push(component.definePreloadedState);
      }

      return componentDidImport;
    }()
  }, {
    key: 'routeWillRender',
    value: function () {
      function routeWillRender(route) {
        var _this = this;

        // clear initialState when new route render
        this.initialState = {};

        // execute user defined preloadedState
        var definePreloadedStateProps = Object.assign({}, this.componentProps, { route: route });
        var queries = this.preloadedStateGenerators.map(function (fn) {
          return fn(definePreloadedStateProps);
        });
        return Promise.map(queries, function (state) {
          return Object.assign(_this.initialState, state);
        });
      }

      return routeWillRender;
    }()
  }, {
    key: 'wrapElement',
    value: function () {
      function wrapElement(appElement) {
        var store = createStore(this.reducers, this.initialState);
        var wrapedElements = react.createElement(Provider, { store: store }, appElement);
        this.state = store.getState();
        return wrapedElements;
      }

      return wrapElement;
    }()
  }, {
    key: 'appendToHead',
    value: function () {
      function appendToHead($head) {
        $head.append('<script data-coren>\n      window.__PRELOADED_STATE__ = ' + String(JSON.stringify(this.state)) + '\n      </script>');
      }

      return appendToHead;
    }()
  }, {
    key: 'wrapClientImport',
    value: function () {
      function wrapClientImport() {
        return '\n      import {Provider} from \'react-redux\';\n      import configureStore from \'' + String(this.configureStore) + '\';\n      const preloadedState = window.__PRELOADED_STATE__;\n      delete window.__PRELOADED_STATE__;\n      const store = configureStore(preloadedState);';
      }

      return wrapClientImport;
    }()
  }, {
    key: 'wrapClientRender',
    value: function () {
      function wrapClientRender($children) {
        return '\n      <Provider store={store}>\n        ' + String($children) + '\n      </Provider>';
      }

      return wrapClientRender;
    }()
  }]);

  return ReduxCollector;
}();

module.exports = ReduxCollector;