var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var co = require('co');
var pathToRegexp = require('path-to-regexp');

var _require = require('lodash'),
    isEmpty = _require.isEmpty,
    flatten = _require.flatten;
// create a match function


var createMatch = function createMatch(url) {
  return function (componentUrl) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    // exact default value is as same as react router default exact
    var exact = options.exact || false;
    var re = pathToRegexp(componentUrl, [], { end: exact });
    return re.exec(url);
  };
};

// uniformed data format
var route = function route(path, data) {
  return { path: path, data: data, match: createMatch(path) };
};

// homeRoute default to "/", no data, match would be compare to "/"
var homeRoute = route("/");

var RouterUrl = function () {
  function RouterUrl(url) {
    _classCallCheck(this, RouterUrl);

    this.url = url;
  }

  _createClass(RouterUrl, [{
    key: 'getUrls',
    value: function () {
      function getUrls() {
        // why return Promise with array?
        // because RouterParamUrl return Promise with array of urls
        // so we make these two class return same data format
        return Promise.resolve([route(this.url)]);
      }

      return getUrls;
    }()
  }]);

  return RouterUrl;
}();

var RouterParamUrl = function () {
  function RouterParamUrl(_ref) {
    var url = _ref.url,
        _ref$dataProvider = _ref.dataProvider,
        dataProvider = _ref$dataProvider === undefined ? function () {
      return Promise.resolve([]);
    } : _ref$dataProvider;

    _classCallCheck(this, RouterParamUrl);

    this.url = url;
    this.toPath = pathToRegexp.compile(this.url);
    this.dataProvider = dataProvider;
  }

  _createClass(RouterParamUrl, [{
    key: 'getUrls',
    value: function () {
      function getUrls() {
        var _this = this;

        return this.dataProvider().then(function (data) {
          return data.map(function (row) {
            try {
              return route(_this.toPath(row), row);
            } catch (err) {
              // row not pass toPath, will throw TypeError
              // https://github.com/pillarjs/path-to-regexp#compile-reverse-path-to-regexp
              if (err instanceof TypeError) {
                return null;
              }

              // another error, throw
              throw err;
            }
          })
          // filter null
          .filter(function (row) {
            return row;
          });
        });
      }

      return getUrls;
    }()
  }]);

  return RouterParamUrl;
}();

var RoutesCollector = function () {
  function RoutesCollector(_ref2) {
    var componentProps = _ref2.componentProps;

    _classCallCheck(this, RoutesCollector);

    // urls collected from component, RouterUrl or RouterParamUrl
    this.urlPromises = [];
    // routes generated in prepare from this.urls
    this.routes = [];
    this.componentProps = componentProps;
  }

  _createClass(RoutesCollector, [{
    key: 'ifEnter',
    value: function () {
      function ifEnter(component) {
        return component.defineRoutes;
      }

      return ifEnter;
    }()
  }, {
    key: 'componentDidImport',
    value: function () {
      function componentDidImport(id, component) {
        var props = Object.assign({}, this.componentProps, { Url: RouterUrl, ParamUrl: RouterParamUrl });
        this.urlPromises.push(component.defineRoutes(props).getUrls());
      }

      return componentDidImport;
    }()
  }, {
    key: 'appWillRender',
    value: function () {
      function appWillRender() {
        var self = this;
        return co(function* () {
          var urls = yield self.urlPromises;
          self.routes = flatten(urls);
        });
      }

      return appWillRender;
    }()

    // default render "/" if empty

  }, {
    key: 'getRoutes',
    value: function () {
      function getRoutes() {
        return isEmpty(this.routes) ? [homeRoute] : this.routes;
      }

      return getRoutes;
    }()
  }, {
    key: 'wrapClientImport',
    value: function () {
      function wrapClientImport() {
        return '\n      import {BrowserRouter as Router} from \'react-router-dom\';\n    ';
      }

      return wrapClientImport;
    }()
  }, {
    key: 'wrapClientRender',
    value: function () {
      function wrapClientRender($children) {
        return '\n      <Router>\n        ' + String($children) + '\n      </Router>\n    ';
      }

      return wrapClientRender;
    }()
  }]);

  return RoutesCollector;
}();

RoutesCollector.homeRoute = homeRoute;
module.exports = RoutesCollector;