var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('react-dom/server'),
    _renderToString = _require.renderToString;

var _require2 = require('react-router-dom'),
    StaticRouter = _require2.StaticRouter;

var react = require('react');
var cheerio = require('cheerio');

var _require3 = require('../collectors/routes-collector'),
    homeRoute = _require3.homeRoute;

var MultiRoutesRenderer = function () {
  function MultiRoutesRenderer(_ref) {
    var app = _ref.app,
        _ref$js = _ref.js,
        js = _ref$js === undefined ? [] : _ref$js,
        _ref$css = _ref.css,
        css = _ref$css === undefined ? [] : _ref$css,
        _ref$plugins = _ref.plugins,
        plugins = _ref$plugins === undefined ? [] : _ref$plugins,
        skipssr = _ref.skipssr;

    _classCallCheck(this, MultiRoutesRenderer);

    this.app = app;
    this.js = js;
    this.css = css;
    this.plugins = plugins;
    this.skipssr = skipssr;
  }

  _createClass(MultiRoutesRenderer, [{
    key: 'triggerPluginsLifecycle',
    value: function () {
      function triggerPluginsLifecycle(lifecycle, props) {
        this.plugins.forEach(function (plugin) {
          if (plugin[lifecycle]) {
            plugin[lifecycle](props);
          }
        });
      }

      return triggerPluginsLifecycle;
    }()
  }, {
    key: 'getRoutes',
    value: function () {
      function getRoutes() {
        var routesCollector = this.app.getCollector("routes");
        if (!routesCollector) {
          console.log('no RoutesCollector found, use "/" to render');
        }

        return routesCollector ? routesCollector.getRoutes() : [homeRoute];
      }

      return getRoutes;
    }()

    // import => prepare => construct => render => html

  }, {
    key: 'renderToString',
    value: function () {
      var _ref2 = _asyncToGenerator(function* () {
        var _this = this;

        // import
        var app = this.app['import']();

        yield this.app.appWillRender();

        var routes = this.getRoutes();
        var results = [];

        var _loop = function* _loop(i) {
          yield _this.app.routeWillRender(routes[i]);
          var context = {};
          var appElement = react.createElement(StaticRouter, { location: routes[i].path, context: context }, react.createElement(app));

          // wrapElement
          _this.app.collectors.forEach(function (collector) {
            if (collector.wrapElement) {
              appElement = collector.wrapElement(appElement);
            }
          });

          var markup = _renderToString(appElement);

          var template = createTemplate();
          var $ = cheerio.load(template, { decodeEntities: false });
          var $head = $('head');
          var $body = $('body');

          // plugin lifecycle: appDidRender
          _this.triggerPluginsLifecycle('appDidRender', { $head: $head, $body: $body });

          // insert bundles
          _this.js.forEach(function (bundle) {
            $('body').append('<script src="' + String(bundle) + '"></script>');
            // plugin lifecycle: jsDidAppend
            _this.triggerPluginsLifecycle('jsDidAppend', { link: bundle, $head: $head, $body: $body });
          });

          // insert css
          _this.css.forEach(function (link) {
            $('head').append('<link rel="stylesheet" href="' + String(link) + '">');
            // plugin lifecycle: cssDidAppend
            _this.triggerPluginsLifecycle('cssDidAppend', { link: link, $head: $head, $body: $body });
          });

          // insert rendered html
          $('#root').html(_this.skipssr ? '' : markup);

          // insert collectors' head and body
          _this.app.collectors.forEach(function (collector) {
            if (collector.appendToHead) {
              collector.appendToHead($head);
            }

            if (collector.appendToBody) {
              collector.appendToBody($body);
            }
          });
          results.push({ route: routes[i].path, html: $.html() });
        };

        for (var i = 0; i < routes.length; i++) {
          yield* _loop(i);
        }

        return results;
      });

      function renderToString() {
        return _ref2.apply(this, arguments);
      }

      return renderToString;
    }()
  }]);

  return MultiRoutesRenderer;
}();

function createTemplate() {
  return '\n  <!doctype html>\n  <html>\n  <head>\n  <meta charset="utf-8">\n  <meta name="viewport" content="width=device-width, initial-scale=1">\n  </head>\n  <body><div id="root"></div></body>\n  </html>\n  ';
}

module.exports = MultiRoutesRenderer;