var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('react-dom/server'),
    _renderToString = _require.renderToString;

var _require2 = require('react-router-dom'),
    StaticRouter = _require2.StaticRouter;

var react = require('react');
var cheerio = require('cheerio');

var SingleRouteRenderer = function () {
  function SingleRouteRenderer(_ref) {
    var _ref$route = _ref.route,
        route = _ref$route === undefined ? '/' : _ref$route,
        app = _ref.app,
        _ref$js = _ref.js,
        js = _ref$js === undefined ? [] : _ref$js,
        _ref$css = _ref.css,
        css = _ref$css === undefined ? [] : _ref$css;

    _classCallCheck(this, SingleRouteRenderer);

    this.route = route;
    this.app = app;
    this.js = js;
    this.css = css;
  }

  // import => appWillRender => routeWillRender => wrapElement => (render) => construct => html


  _createClass(SingleRouteRenderer, [{
    key: 'renderToString',
    value: function () {
      function renderToString() {
        var _this = this;

        var app = this.app['import']();
        var context = {};
        var appElement = react.createElement(StaticRouter, { location: this.route, context: context }, react.createElement(app));

        return this.app.appWillRender().then(function () {
          // route will render
          _this.app.routeWillRender();
          // wrapElement
          _this.app.collectors.forEach(function (collector) {
            if (collector.wrapElement) {
              appElement = collector.wrapElement(appElement);
            }
          });

          // ssr
          // trigger componentDidConstruct in collectors
          var markup = _renderToString(appElement);

          var template = createTemplate();
          var $ = cheerio.load(template, { decodeEntities: false });
          // insert js
          _this.js.forEach(function (bundle) {
            return $('body').append('<script src="' + String(bundle) + '"></script>');
          });

          // insert css
          _this.css.forEach(function (link) {
            return $('head').append('<link rel="stylesheet" href="' + String(link) + '">');
          });

          // insert rendered html
          $('#root').html(markup);

          // insert collectors' head and body
          _this.app.collectors.forEach(function (collector) {
            if (collector.appendToHead) {
              collector.appendToHead($('head'));
            }

            if (collector.appendToBody) {
              collector.appendToBody($('body'));
            }
          });
          return $.html();
        });
      }

      return renderToString;
    }()
  }]);

  return SingleRouteRenderer;
}();

function createTemplate() {
  return '\n  <!doctype html>\n  <html>\n  <head>\n  <meta charset="utf-8">\n  <meta name="viewport" content="width=device-width, initial-scale=1">\n  </head>\n  <body><div id="root"></div></body>\n  </html>\n  ';
}

module.exports = SingleRouteRenderer;