Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = createShareConfig;

var _path = require('path');

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _getBabelConfig = require('../babel/get-babel-config');

var _getBabelConfig2 = _interopRequireDefault(_getBabelConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function createShareConfig(_ref) {
  var dir = _ref.dir,
      _ref$dev = _ref.dev,
      dev = _ref$dev === undefined ? false : _ref$dev,
      corenConfig = _ref.corenConfig;

  var env = dev ? 'development' : 'production';
  // setup plugins
  var plugins = [new _webpack2['default'].DefinePlugin({
    "process.env": {
      NODE_ENV: JSON.stringify(env)
    }
  })];
  var config = {
    // target: 'node',
    resolve: {
      extensions: ['.js']
    },
    plugins: plugins,
    externals: [],
    module: {
      rules: [{
        test: /\.js$/,
        use: {
          loader: 'babel-loader',
          options: (0, _getBabelConfig2['default'])(dir)
        },
        exclude: (0, _path.resolve)(dir, "node_modules")
      }]
    }
  };
  if (corenConfig.webpack) {
    if (corenConfig.webpack.plugins) {
      config = Object.assign({}, config, {
        plugins: [].concat(_toConsumableArray(config.plugins), _toConsumableArray(corenConfig.webpack.plugins))
      });
    }

    if (corenConfig.webpack.module && corenConfig.webpack.module.rules) {
      config = Object.assign({}, config, {
        module: {
          rules: [].concat(_toConsumableArray(config.module.rules), _toConsumableArray(corenConfig.webpack.module.rules))
        }
      });
    }
    if (corenConfig.webpack.externals) {
      config = Object.assign({}, config, {
        externals: [].concat(_toConsumableArray(config.externals), _toConsumableArray(corenConfig.webpack.externals))
      });
    }
  }
  return config;
}
module.exports = exports['default'];